/*-
 * ~~~~~~licensing~~~~~~
 * test-producers
 * ==========
 * Copyright (C) 2020 - 2022 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.api;

import java.util.List;

import ru.entaxy.platform.base.objects.factory.EntaxyFactory;

public interface EntaxyProducer {

	public interface EntaxyProducerListener {
		
		public void factoryAdded(String factoryId, String factoryType, EntaxyProducer producer);
		public void factoryRemoved(String factoryId, String factoryType, EntaxyProducer producer);
		
	}
	
	public void addListener(EntaxyProducerListener listener);
	public void removeListener(EntaxyProducerListener listener);
	
	public String getProducerId();
	
	public List<String> getSupportedTypes();
	
	public List<EntaxyFactory> getAllFactories();
	public List<EntaxyFactory> getFactoriesForType(String factoryType);
	public EntaxyFactory getFactoryById(String factoryId);

}
