/*-
 * ~~~~~~licensing~~~~~~
 * test-producers
 * ==========
 * Copyright (C) 2020 - 2022 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.executor.support;

import org.osgi.service.component.ComponentContext;
import org.osgi.service.component.annotations.Activate;
import org.osgi.service.component.annotations.CollectionType;
import org.osgi.service.component.annotations.Component;
import org.osgi.service.component.annotations.Reference;
import org.osgi.service.component.annotations.ReferenceCardinality;

import ru.entaxy.platform.core.artifact.service.ArtifactService;

@Component(immediate = true)
public class ArtifactsHelper {

	protected static ArtifactsHelper instance = null;
	
	public static ArtifactsHelper getInstance() {
		return ArtifactsHelper.instance;
	}
	
	protected ArtifactService artifactService;
	
	@Activate
	public void activate(ComponentContext componentContext) {
		// Artifacts.registerSupport(Blueprint.class);
		ArtifactsHelper.instance = this;
	}

	public ArtifactService getArtifactService() {
		return artifactService;
	}

	@Reference(unbind = "removeArtifactService", cardinality = ReferenceCardinality.MANDATORY, collectionType = CollectionType.SERVICE)
	public void setArtifactService(ArtifactService artifactService) {
		this.artifactService = artifactService;
	}
	
	public void removeArtifactService(ArtifactService artifactService) {
		this.artifactService = null;
	}
	
	
}
