/*-
 * ~~~~~~licensing~~~~~~
 * test-producers
 * ==========
 * Copyright (C) 2020 - 2022 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.wrapper;

import ru.entaxy.platform.base.objects.factory.EntaxyFactory.RefFieldInfo;

public class RefFieldWrapper extends FieldWrapper implements RefFieldInfo {

	public RefFieldWrapper(RefFieldInfo origin) {
		super(origin);
	}

	@Override
	public boolean isBackRef() {
		return ((RefFieldInfo)origin).isBackRef();
	}

	@Override
	public boolean isRefByValueOnly() {
		return ((RefFieldInfo)origin).isRefByValueOnly();
	}

	@Override
	public String getRefField() {
		return ((RefFieldInfo)origin).getRefField();
	}

}
